#!/usr/bin/perl

BEGIN {
	require "fatlib.pl";
};

use utf8;
use strict;

# "1.150n"-"1.199n"
my $VER="V.1.166n(nanakochi123456)";
my $tarball="power110921.tar.gz";
my $data_update=<<EOM;
<li>2011/9/01 04:05 東京電力エリア更新(埼玉)、郵便番号データベース更新</li>
<li>2011/8/10 12:30 東京電力エリア更新(千葉・神奈川・静岡)</li>
<li>2011/8/03 07:18 runtable.txt の内容を削除。ただしファイルは必要です。</li>
<li>2011/7/21 20:25 一部の郵便番号を検索できないのを修正。なお、それでも地域が多すぎる場合があります。</li>
<li>2011/7/21 20:00 東北エリア大幅更新　グループ30まであります。</li>
<li>2011/7/21 16:10 東京電力エリア更新（神奈川・埼玉）</li>
<li>2011/7/19 09:20 東北エリアを可能な限り町名を追加した。及び、郵便番号データベースの更新</li>
<li>2011/7/08 17:48 エリアの群馬・神奈川が更新されました。</li>
EOM

my $engine_update=<<EOM;
<li>2011/8/04 14:30 各電力使用率を小数点１桁まで表示するようにした。</li>
<li>2011/8/04 04:12 当方でミラーフロントを作成した。</li>
<li>2011/8/03 08:50 空欄のままボタンを押した時の表示を修正した。</li>
<li>2011/8/03 07:22 実施の時のみ強調表示をするようにした。(PCのみ)</li>
<li>2011/8/03 07:18 runtable.txt の内容を削除し、手動で追加できるようにした。また、その対応に為に、データがない場合、「実施せず」をデフォルトに入れるようにした。</li>
<li>2011/7/25 09:00 気づいていなかったので。汗 関西電気のでんき予報の新書式に対応した。</li>
<li>2011/7/22 07:23 書式チェックを加えたことにより発生したバグ修正</li>
<li>2011/7/22 07:22 TOPページ(PCの日本語のみ）に、でんき予報サイトから現在の可能な限りの電力会社の使用率を表示するようにした。</li>
<li>2011/7/22 01:52 モバイルの出力を、検索結果によって東北の件数が多いため、3日分におさえた。</li>
<li>2011/7/22 01:28 再び郵便番号検索に関してバグフィックス</li>
<li>2011/7/22 01:05 東北エリアの郵便番号検索に不十分な部分があったため、その部分を完全に組みなおしました。</li>
<li>2011/7/21 20:00 東北エリアグループ30までに対応、カナ検索廃止</li>
<li>2011/7/14 19:35 中部電力のでんき予報に対応した。</li>
<li>2011/7/14 18:30 東北電力のでんき予報に対応した。</li>
<li>2011/7/08 13:15 IE9対策のために、Twitterのハッシュタグをプロクシ動作をさせた。</li>
<li>2011/7/08 04:11 Twitterのポストに、過去に使用していた。#jishin_power ハッシュタグを追加した。</li>
<li>2011/7/07 07:57 直接は関係ありませんが、Twitterによる関西電力、東北電力の使用率お知らせに対応した。</li>
<li>2011/7/06 12:00 一部ブラウザで言語設定により英語表示になってしまうのを修正した。また、マスタサイトのみIPV6に試験対応をした。</li>
<li>2011/7/05 09:00 東京電力の使用量で、当日以外の色を変更した。</li>
<li>2011/7/04 12:30 関西電力の使用量一覧を追加した。</li>
<li>2011/7/04 02:06 東京電力のでんき予報をの結果を、任意の日付で閲覧できるようにした。(PCのみ)</li>
<li>2011/7/02 05:00 東京電力のでんき予報の昨日のデータ閲覧、及び、過去３年間のデータ（同日）を閲覧できるようにした。(PCのみ)また、使用率に応じて色を変更するようにした。(PCのみ)</li>
<li>2011/7/01 03:00 東京電力のでんき予報に対応。11:32追記：ダウンロードファイル名が誤っていたのを修正。</li>
EOM

#------------
use Encode;
use CGI;
use HTTP::Lite;
use Encode qw/decode decode_utf8/;
use Encode::Guess;

require "common.pl";

$VER=~s/\(.*//g;

if($ENV{QUERY_STRING} eq "kepco" || $ENV{QUERY_STRING} eq "tohoku" || $ENV{QUERY_STRING} eq "cepco") {
	print <<EOM;
Content-type: text/plain

EOM
	$ENV{QUERY_STRING}=~s/\/\.//g;
	if(open(R,"cache/$ENV{QUERY_STRING}.twitter")) {
		my $buf;
		foreach(<R>) {
			$buf.=$_;
		}
		Encode::from_to($buf, "utf8", "shiftjis" );
		print $buf;
		close(R);
	}
	exit;
}

if($ENV{QUERY_STRING}=~/cmd\=twitter\_proxy/) {
	&twitter_proxy;
	exit;
}

my $nojapaneseflg=0;
$nojapaneseflg=1 if($ENV{HTTP_ACCEPT_LANGUAGE}=~/en/);
$nojapaneseflg=0 if($ENV{HTTP_ACCEPT_LANGUAGE}=~/ja/);
my $mobileflg=0;
$mobileflg=1 if($ENV{HTTP_USER_AGENT}=~/DoCoMo|UP\.Browser|KDDI|SoftBank|Voda[F|f]one|J\-PHONE|DDIPOCKET|WILLCOM|iPod|PDA|Mobile|Semulator/);

$mobileflg=0 if($ENV{QUERY_STRING}=~'p');
$mobileflg=1 if($ENV{QUERY_STRING}=~'m');
$nojapaneseflg=0 if($ENV{QUERY_STRING}=~'j');
$nojapaneseflg=1 if($ENV{QUERY_STRING}=~'e');

my $english_file="english.html";
my $english_mobile_file="english_mobile.html";
my $mobile_file="mobile.html";
my $pc_file="pc.html";
my $mobile_update_file="mobile_update.html";
my $mobile_setuden_file="mobile_setuden.html";

&gzip_compress("Content-type: text/html; charset=utf-8");
my $body;
my $file;
my $kanaflg=0;
my $updatetitle;
if($nojapaneseflg) {
	if($mobileflg) {
		$file=$english_mobile_file;
	} else {
		$file=$english_file;
	}
} elsif($ENV{QUERY_STRING}=~/^mju/) {
	$file=$mobile_update_file;
	$kanaflg=1;
} elsif($ENV{QUERY_STRING}=~/^mjs/) {
	$file=$mobile_setuden_file;
	$kanaflg=1;
} elsif($mobileflg) {
	$file=$mobile_file;
	$kanaflg=1;
} else {
	$file=$pc_file;
}

if(open(R,"<:utf8","$file")) {
	foreach(<R>) {
		if(/\@\@/) {
			s/\@\@VER\@\@/$VER/;
			s/\@\@INCLUDE\=\"(.+)\"\@\@/@{[&include($1)]}/;
			s/\@\@INCLUDESCRIPT\=\"(.+)\"\@\@/@{[&include($1,1)]}/;
			s/\@\@QRCODEEN\@\@/@{[&qrcode_link_en]}/;
			s/\@\@QRCODEJP\@\@/@{[&qrcode_link]}/;
			s/\@\@DATAUPDATE\@\@/$data_update/;
			s/\@\@ENGINEUPDATE\@\@/$engine_update/;
			s/\@\@TARBALL\@\@/$tarball/;
			s/\@\@POWERUSAGE\@\@/@{[&powerusage]}/;
		}
		$body.=$_;
	}
	close(R);
} else {
	$body="$file not found. sorry.";
}
if($kanaflg) {
	$body=&z2h($body);
}
binmode(STDOUT, ":utf8");
print "$body\n";
close(STDOUT);
exit;

sub include {
	my ($file,$mode)=@_;
	my $body="";
	if(open(I,"<:utf8","$file")) {
		my $div=$file;
		$div=~s/\.//g;
		$body.=<<EOM if($mode ne 1);
<div id="$div">
EOM
		foreach(<I>) {
			$body.=$_;
		}
		close(I);
		$body.="</div>\n" if($mode ne 1);
	}
	$body;
}

sub qrcode_link {
	my($basehref, $basehost, $basepath)=&getbasehref;
	my $string=&enc("$basehost$basepath");
	if(&load_module("GD") && &load_module("GD::Barcode")) {
		return <<FIN;
携帯へURLを送るには、こちらのQRコードをご利用下さい。<br />
<img alt="QRCode" src="$basehost$basepath/area.cgi?m=qr\&amp;str=$string" />

FIN
	}
	'';
}

sub qrcode_link_en {
	my($basehref, $basehost, $basepath)=&getbasehref;
	my $string=&enc("$basehost$basepath?e");
	if(&load_module("GD::Barcode")) {
		return <<FIN;
If you have mobile phone to transfer this site, use this barcode.
<br />
<img alt="QRCode" src="$basehost$basepath/area.cgi?m=qr\&amp;str=$string" />

FIN
	}
	'';
}

sub powerusage {
	my $powerusage_url="http://denkiyohou.daiba.cx/?allcompany";
	my $http=new HTTP::Lite;
	$http->method("GET");
	$http->http11_mode(1);
	$http->add_req_header("User-Agent","KeikakuTeiden ($::basepath))");
	my $req=$http->request($powerusage_url);
	my $body=' ';
	if($req eq 200) {
		$body=$http->body();
		$body=&force_decode($body);
		my $out;
		my $crlfcnt=0;
		foreach(split(/\n/,$body)) {
			$out.="$_";
			if($crlfcnt eq 0) {
				$crlfcnt=1;
			} else {
				$crlfcnt=0;
				$out.="<br />";
			}
		}
		return $out;
	}
	return ' ';
}

sub twitter_proxy {
	my $query=new CGI;
	my $rpp=$query->param('rpp');
	my $q=&enc($query->param('q'));
	my $near=$query->param('near');
	my $within=$query->param('widhin');
	my $units=$query->param('units');
	my $since_id=$query->param('since_id');
	my $callback=$query->param('callback');

	my $searchurl="http://search.twitter.com/search.json";
	$searchurl.="?rpp=$rpp&callback=$callback&q=$q";
	my ($status,$stream)=&httpcl($searchurl);

	if($status eq 0) {
		&gzip_compress("Content-type: application/json");
		print $stream;
	} else {
		print "Content-type: text/plain\n\n";
		print "Cant get '$searchurl'\n";
	}
	exit;
}
